=== debian/changelog ===
openrct2 (0.4.5+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Mathias Gibbens <gibmat@debian.org>  Sat, 17 Jun 2023 17:25:18 +0000

openrct2 (0.4.5+ds-1) unstable; urgency=medium

  * Upload to unstable
  * Add openrct2-openmsx and openrct2-opensfx as Recommends in d/control

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 11 Jun 2023 14:09:16 +0000

openrct2 (0.4.5+ds-1~exp1) experimental; urgency=medium

  * New upstream release
    - Refresh patches as needed
  * Bump minimum required version of openrct2-objects in d/control

 -- Mathias Gibbens <gibmat@debian.org>  Tue, 09 May 2023 00:27:18 +0000

openrct2 (0.4.4+ds-1~exp1) experimental; urgency=medium

  * New upstream release
    - Refresh/drop/add patches as needed
  * Update years in d/copyright
  * d/control:
    - Update Build-Depends on libfontconfig1-dev => libfontconfig-dev
    - Drop versioned Build-Depends on nlohmann-json3-dev
    - Bump Standards-Version
    - Bump minimum required version of openrct2-objects

 -- Mathias Gibbens <gibmat@debian.org>  Wed, 29 Mar 2023 03:02:55 +0000
