=== debian/changelog ===
openrct2 (0.4.6+ds-1ubuntu1) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Disable LTO to fix FTBFS on amd64 and arm64.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 05 Sep 2023 17:17:05 +0200

openrct2 (0.4.6+ds-1) unstable; urgency=medium

  * New upstream release
    - Add/refresh/drop patches as needed
  * d/control:
    - Update/sort Build-Depends
    - Update supported architectures
    - Bump minimum required version of openrct2-title-sequences

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 03 Sep 2023 17:52:14 +0000

openrct2 (0.4.5+ds-1ubuntu1) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Disable LTO to fix FTBFS on amd64 and arm64.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 12 Jun 2023 14:25:13 +0200
