=== debian/control ===
--- 
+++ 
@@ -1,9 +1,14 @@
 Source: openrct2
 Section: contrib/games
 Priority: optional
-Maintainer: Mathias Gibbens <gibmat@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Mathias Gibbens <gibmat@debian.org>
 Rules-Requires-Root: no
-Build-Depends: debhelper-compat (= 13), cmake, pkg-config, libssl-dev, libcurl4-openssl-dev, libfontconfig-dev, libbenchmark-dev, duktape-dev, libzip-dev, libicu-dev, libsdl2-dev, libsdl2-ttf-dev, libspeexdsp-dev, nlohmann-json3-dev, libgzstream-dev, libflac-dev, libvorbis-dev
+Build-Depends: debhelper-compat (= 13),
+               cmake, pkg-config,
+               duktape-dev, libcurl4-openssl-dev, libflac-dev, libfontconfig-dev,
+               libgzstream-dev, libicu-dev, libsdl2-dev, libsdl2-ttf-dev,
+               libspeexdsp-dev, libssl-dev, libvorbis-dev, libzip-dev, nlohmann-json3-dev
 Standards-Version: 4.6.2
 Homepage: https://openrct2.io/
 Vcs-Git: https://salsa.debian.org/gibmat/openrct2.git
@@ -11,9 +16,9 @@
 
 Package: openrct2
 # Only little-endian architectures are supported (https://github.com/OpenRCT2/OpenRCT2/issues/16096)
-Architecture: any-i386 any-amd64 alpha arm64 armel armhf ia64 mipsel mips64el ppc64el riscv64 sh4 x32
+Architecture: any-i386 any-amd64 alpha arc arm64 armel armhf ia64 loong64 mips64el ppc64el riscv64 sh4 x32
 Multi-Arch: foreign
-Depends: openrct2-data (= ${source:Version}), openrct2-objects (>= 1.3.11), openrct2-title-sequences (>= 0.4.0), ${misc:Depends}, ${shlibs:Depends}
+Depends: openrct2-data (= ${source:Version}), openrct2-objects (>= 1.3.11), openrct2-title-sequences (>= 0.4.6), ${misc:Depends}, ${shlibs:Depends}
 Recommends: openrct2-openmsx (>= 1.3.1), openrct2-opensfx (>= 1.0.3), zenity
 Suggests: innoextract
 Description: Open-source re-implementation of RollerCoaster Tycoon 2
