=== debian/changelog ===
openrct2 (0.4.7+ds-1ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Disable LTO to fix FTBFS on amd64 and arm64.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 02 Jan 2024 10:27:35 +0100

openrct2 (0.4.7+ds-1) unstable; urgency=medium

  * New upstream release
    - Drop/refresh patches as needed
  * Update minimum required versions of openrct2-objects and openrct2-openmsx
  * Add a couple default paths for game assets installed with
    `game-data-packager` and mention in d/README.Debian

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 31 Dec 2023 18:38:10 +0000

openrct2 (0.4.6+ds-1ubuntu2) noble; urgency=medium

  * No-change rebuild for ICU soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 11:07:35 +0100
