=== debian/control ===
--- 
+++ 
@@ -18,8 +18,8 @@
 # Only little-endian architectures are supported (https://github.com/OpenRCT2/OpenRCT2/issues/16096)
 Architecture: any-i386 any-amd64 alpha arc arm64 armel armhf ia64 loong64 mips64el ppc64el riscv64 sh4 x32
 Multi-Arch: foreign
-Depends: openrct2-data (= ${source:Version}), openrct2-objects (>= 1.3.11), openrct2-title-sequences (>= 0.4.6), ${misc:Depends}, ${shlibs:Depends}
-Recommends: openrct2-openmsx (>= 1.3.1), openrct2-opensfx (>= 1.0.3), zenity
+Depends: openrct2-data (= ${source:Version}), openrct2-objects (>= 1.3.13), openrct2-title-sequences (>= 0.4.6), ${misc:Depends}, ${shlibs:Depends}
+Recommends: openrct2-openmsx (>= 1.5), openrct2-opensfx (>= 1.0.3), zenity
 Suggests: innoextract
 Description: Open-source re-implementation of RollerCoaster Tycoon 2
  OpenRCT2 is an open-source re-implementation of RollerCoaster Tycoon 2
