## openrct2 0.4.10%2Bds

=== src/openrct2-ui/CMakeLists.txt ===
--- 
+++ 
@@ -202,7 +202,7 @@
     endif()
 
 
-    if(${OPENRCT2_BRANCH} EQUAL master)
+    if(OPENRCT2_BRANCH EQUAL master)
         set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${OPENRCT2_VERSION_TAG}")
     else()
         set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${OPENRCT2_VERSION_TAG} ${OPENRCT2_BRANCH}")
